from flask import Flask, redirect, render_template_string
import base64

app = Flask(__name__)

@app.route('/hello/<user>')
def dynamic_hello(user):
    user = base64.b64decode(user)
    user = user.decode("utf-8")
    return render_template_string('user: ' + user)

@app.route('/')
def index():
    user = base64.b64encode(b"test")
    user = user.decode("utf-8")
    url = f"/hello/{user}"
    return redirect(url, code=302)
